# required for pushd to work..
SHELL = /bin/bash


# set by: PATH_TO_OUTDATED_PACKAGES=/some/path/outdated_packages.py
OUTDATED_PACKAGES = ${PATH_TO_OUTDATED_PACKAGES}

NODE_PATH=./node_modules
WEBPACK=./node_binaries/webpack
GRUNT=./node_binaries/grunt

.PHONY: clean
## Cleanup compiled and cache py files
clean:
	make test-clean
	find . -type f \( -iname '*.c' -o -iname '*.pyc' -o -iname '*.so' -o -iname '*.orig' \) -exec rm '{}' ';'


.PHONY: test
## run test-clean and tests
test:
	make test-clean
	make test-only


.PHONY: test-clean
## run test-clean and tests
test-clean:
	rm -rf coverage.xml htmlcov junit.xml pylint.log result
	find . -type d -name "__pycache__" -prune -exec rm -rf '{}' ';'
	find . -type f \( -iname '.coverage.*' \) -exec rm '{}' ';'


.PHONY: test-only
## Run tests only without cleanup
test-only:
	PYTHONHASHSEED=random \
	py.test -x -vv -r xw -p no:sugar \
	--cov-report=term-missing --cov-report=html \
	--cov=rhodecode rhodecode


.PHONY: test-only-mysql
## run tests against mysql
test-only-mysql:
	PYTHONHASHSEED=random \
	py.test -x -vv -r xw -p no:sugar \
	--cov-report=term-missing --cov-report=html \
    --ini-config-override='{"app:main": {"sqlalchemy.db1.url": "mysql://root:qweqwe@localhost/rhodecode_test?charset=utf8"}}' \
    --cov=rhodecode rhodecode


.PHONY: test-only-postgres
## run tests against postgres
test-only-postgres:
	PYTHONHASHSEED=random \
	py.test -x -vv -r xw -p no:sugar \
	--cov-report=term-missing --cov-report=html \
    --ini-config-override='{"app:main": {"sqlalchemy.db1.url": "postgresql://postgres:qweqwe@localhost/rhodecode_test"}}' \
    --cov=rhodecode rhodecode

.PHONY: docs
## build docs
docs:
	(cd docs; nix-build default.nix -o result; make clean html)


.PHONY: docs-clean
## Cleanup docs
docs-clean:
	(cd docs; make clean)


.PHONY: docs-cleanup
## Cleanup docs
docs-cleanup:
	(cd docs; make cleanup)


.PHONY: web-build
## Build JS packages static/js
web-build:
	NODE_PATH=$(NODE_PATH) $(GRUNT)

	# check required files
	STATIC_CHECK="/robots.txt /502.html \
				  /js/scripts.min.js /js/rhodecode-components.js \
				  /css/style.css /css/style-polymer.css /css/style-ipython.css"

	for file in $STATIC_CHECK;
	do
		if [ ! -f rhodecode/public/$file ]; then
		  echo "Missing $file expected after web-build"
		  exit 1
		fi
	done

.PHONY: pip-packages
## Show outdated packages
pip-packages:
	python ${OUTDATED_PACKAGES}


.PHONY: build
## Build sdist/egg
build:
	python -m build


.PHONY: dev-env
## make dev-env based on the requirements files and install develop of packages
dev-env:
	pip install build virtualenv
	pushd ../rhodecode-vcsserver/ && make dev-env && popd
	pip wheel --wheel-dir=/home/rhodecode/.cache/pip/wheels -r requirements.txt -r requirements_rc_tools.txt -r requirements_test.txt -r requirements_debug.txt
	pip install --no-index --find-links=/home/rhodecode/.cache/pip/wheels -r requirements.txt -r requirements_rc_tools.txt -r requirements_test.txt -r requirements_debug.txt
	pip install -e .


.PHONY: dev-srv
## run develop server instance, docker exec -it $(docker ps -q --filter 'name=dev-enterprise-ce') /bin/bash
dev-srv:
	pserve --reload .dev/dev.ini

.PHONY: dev-srv-g
## run gunicorn multi process workers
dev-srv-g:
	gunicorn --workers=4 --paste .dev/dev_g.ini --bind=0.0.0.0:10020 --worker-class=gevent --threads=1 --config=configs/gunicorn_config.py --timeout=120


# Default command on calling make
.DEFAULT_GOAL := show-help

.PHONY: show-help
show-help:
	@echo "$$(tput bold)Available rules:$$(tput sgr0)"
	@echo
	@sed -n -e "/^## / { \
		h; \
		s/.*//; \
		:doc" \
		-e "H; \
		n; \
		s/^## //; \
		t doc" \
		-e "s/:.*//; \
		G; \
		s/\\n## /---/; \
		s/\\n/ /g; \
		p; \
	}" ${MAKEFILE_LIST} \
	| LC_ALL='C' sort --ignore-case \
	| awk -F '---' \
		-v ncol=$$(tput cols) \
		-v indent=19 \
		-v col_on="$$(tput setaf 6)" \
		-v col_off="$$(tput sgr0)" \
	'{ \
		printf "%s%*s%s ", col_on, -indent, $$1, col_off; \
		n = split($$2, words, " "); \
		line_length = ncol - indent; \
		for (i = 1; i <= n; i++) { \
			line_length -= length(words[i]) + 1; \
			if (line_length <= 0) { \
				line_length = ncol - indent - length(words[i]) - 1; \
				printf "\n%*s ", -indent, " "; \
			} \
			printf "%s ", words[i]; \
		} \
		printf "\n"; \
	}'
